<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<% 
/////////////////////////////////////////////////////////////////////////////
//                                update.aspx
//                            -------------------
//   begin                : Thur, June 15, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: update.aspx,v 1.0.0.0 R1
//   Function: Update capture file for native windows client.
//  
//   Possible Return Values: ok
//                           badip
//                           nodom
//                           nohost
//                           disabled
//                           911
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;

MINTDNSLib.DNSMANClass sd = new MINTDNSLib.DNSMANClass();
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open(); 
   //Decode user name and password 
   String AuthString = "";
   String UserID = "";
   String Password = "";
   String Host = Request["host"];
   String MyIP = Request["myip"];

   String InUString = Request.ServerVariables["HTTP_Authorization"];
   if ((InUString == null) || (InUString == "")) {
       Response.Status = "401 Not Authorized";
       Response.AddHeader("WWW-Authenticate", "Basic realm=DDNS");
       Response.End();
     }
   else { 
   if (InUString.Substring(0, 5) == "Basic"){AuthString = InUString.Substring(6);}
   if ((AuthString != null) && (AuthString != ""))   {
       AuthString = sd.base64_decode(AuthString);
       string[] User_N_Pass = AuthString.Split(':');
       UserID = User_N_Pass.GetValue(0).ToString().Trim().ToLower();
       Password = User_N_Pass.GetValue(1).ToString().Trim();
   }
   else   {
       Response.Write("911");
       Response.End();
   }        
      }
      //End decode user name and password 

      if ((Host == null) || (Host == ""))
      {
          Response.Write("nohost");
          Response.End();
      }
      else { Host = Host.ToLower(); }
        
      if ((CharCheck(UserID) == false) || (CharCheck(Password) == false) || (CharCheck(Host) == false)) {
          Response.Write("911");
          Response.End();
      }
     
      if ((MyIP == null) || (MyIP == "")) {
          MyIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
          if (MyIP != null)
          {
              MyIP = MyIP.ToLower();
              MyIP = MyIP.Trim();
          }

          if ((MyIP == null) || (MyIP == "unknown")) { MyIP = Request.ServerVariables["REMOTE_ADDR"]; }

          else if (MyIP.IndexOf(",") != -1)
          {
              string[] IPs = MyIP.Split(',');
              //MyIP = IPs.GetValue(IPs.Length -1).ToString().Trim();
                MyIP = IPs.GetValue(0).ToString().Trim();
          }
          }

          if ((sd.IsValidIPAddress(MyIP) != "True")){
            Response.Write("badip");
            Response.End();
          }



          SqlCommand DomUp = new SqlCommand("Client_Update @UserID= '" + UserID + "', @Password='" + sd.base64_encode(Password) + "', @IP='" + MyIP + "', @URL='" + Host + "'", Conn);
          SqlDataReader DomSet = DomUp.ExecuteReader();
    if (DomSet.HasRows == false) { 
            Response.Write("nodom");
            Response.End();
    }
    while (DomSet.Read()) {
    
      if (DomSet["Disabled"].ToString() == "True") {
            Response.Write("disabled");
            Response.End();
      }
      if (DomSet["IP"].ToString() != MyIP)
      {
          sd.UpdateARecord(DomSet["Host"].ToString(), DomSet["Dom"].ToString(), MyIP);
          Response.Write("ok");
          Response.End();
      }
      else { Response.Write("ok"); }  
    }
    DomSet.Close();
    DomUp.Dispose();   
    
 Conn.Close();
 Dispose();  
    
    

    
    
    
    
 %>
 <script runat="server">
    //Validate input + cross site scriptng block.
     bool CharCheck(string input)
        {
            if ((input == null) || (input == "")) { return false; }
         if (input.Length >= 255){ return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
               
                if ((nChar > 41 && nChar < 59) || (nChar > 63 && nChar < 123) || (nChar > 31 && nChar < 33))
                { }
                else
                { return false; }
                }
                return true;
       }
    
</script>
