<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<!--#include file="includes/css.aspx"-->

<% 
/////////////////////////////////////////////////////////////////////////////
//                                eddevaction.aspx
//                            -------------------
//   begin                : Thur, June 15, 2009
//   copyright            : (C) 2009 AdamsLand Computers, DynDNSServices
//   email                : sam@dyndnsservices.com
//
//   Id: eddevaction.aspx,v 1.0.0.0 R1
//   Function: Device manager action file. (Change Domain Name).
//
////////////////////////////////////////////////////////////////////////////
    HttpContext objectHttpContext = HttpContext.Current;
    HttpResponse Response = objectHttpContext.Response;

    Response.CacheControl = "no-cache";
    Response.AddHeader("Pragma", "no-cache");
    Response.Expires = -1;  
    
    
MINTDNSLib.DNSMANClass sd = new MINTDNSLib.DNSMANClass();
if (Request.Cookies["DDNS"] == null) { Response.Redirect("logon.aspx?error=session"); }       
String Userid = Request.Cookies["DDNS"]["user"].ToString();
String Password = Request.Cookies["DDNS"]["pass"].ToString();
String URL = Request["url"];
String New_URL = "";   
String MyIP = "";
String Dom = Request["Dom"];
String Host = Request["Host"].Trim().ToLower();
String CreResult = "";
String DelResp = "";
String Hst1 = "";
String Dmn1 = "";
SqlConnection Conn = new SqlConnection(ConfigurationSettings.AppSettings["DBCon"]);
Conn.Open();


//Begin Flood Detection
String FloodIP = "";
if ((FloodIP == null) || (FloodIP == ""))
{
    FloodIP = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
    if (FloodIP != null)
    {
        FloodIP = FloodIP.ToLower();
        FloodIP = FloodIP.Trim();
    }

    if ((FloodIP == null) || (FloodIP == "unknown")) { FloodIP = Request.ServerVariables["REMOTE_ADDR"]; }

    else if (FloodIP.IndexOf(",") != -1)
    {
        string[] IPs = FloodIP.Split(',');
        FloodIP = IPs.GetValue(IPs.Length -1).ToString().Trim();

    }
}    
SqlCommand FloodLookerCmd = new SqlCommand("Flood_Look @IP='" + FloodIP + "'", Conn);
SqlDataReader FloodReader = FloodLookerCmd.ExecuteReader();
if (FloodReader.Read()) { if ((int)FloodReader["Times"] >= 15) { Response.Redirect("logon.aspx?error=flood");} }
FloodReader.Close();
FloodLookerCmd.Dispose();
//End Flood Detection





    SqlCommand Ulook = new SqlCommand("User_Lookup @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
    SqlDataReader UlookSet = Ulook.ExecuteReader();
    if (UlookSet.HasRows == false) { Response.Redirect("logon.aspx?error=session"); }
    UlookSet.Close();
    Ulook.Dispose();


    if ((Host == null) || (Host == "") || (Dom == null) || (Dom == "") || (URL == null) || (URL == "")) { Response.Redirect("eddev.aspx?error=fields&url=" + URL); }
    else { New_URL = Host + "." + Dom; }
    if (IsOKinput(Host) == false) { Response.Redirect("eddev.aspx?error=input&url=" + URL); }
    if ((IsOKurl(URL) == false) || (IsOKurl(Dom) == false)) { Response.Redirect("eddev.aspx?error=access&url=" + URL); }


    SqlCommand DomCLook = new SqlCommand("Look_Single_Dom @Dom='" + Dom + "', @UserID='" + Userid + "'", Conn);
    SqlDataReader DomCSet = DomCLook.ExecuteReader();
    if (DomCSet.HasRows == false) { Response.Redirect("eddev.aspx?error=access&url=" + URL); }
    DomCSet.Close();
    DomCLook.Dispose();


    SqlCommand HDLook = new SqlCommand("Host_Dom_Look @URL='" + URL + "', @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
    SqlDataReader HDSet = HDLook.ExecuteReader();
    if (HDSet.HasRows == false) { Response.Redirect("eddev.aspx?error=dom&url=" + URL); }
    else {
        while (HDSet.Read()){
    MyIP = HDSet["IP"].ToString();
    if (sd.IsValidIPAddress(MyIP) != "True") { Response.Redirect("eddev.aspx?error=errt&url=" + URL); }
    CreResult = sd.CreateARecord(Host, Dom, MyIP);    
    Hst1 = HDSet["Host"].ToString();
    Dmn1 = HDSet["Dom"].ToString();  
        }  
    }
    HDSet.Close();
    HDLook.Dispose();

    if (CreResult == "EXPIRED") { Response.Redirect("eddev.aspx?error=expire&url=" + URL); }
    if (CreResult == "OK"){ DelResp = sd.DeleteARecord(Hst1, Dmn1); }
    else { Response.Redirect("eddev.aspx?error=dom&url=" + URL); }
    if (DelResp == "OK"){
        SqlCommand UPLook = new SqlCommand("Edit_Domain @URL='" + URL + "', @Host='" + Host + "', @Dom='" + Dom + "', @UserID='" + Userid + "', @Password='" + Password + "'", Conn);
        SqlDataReader UPSet = UPLook.ExecuteReader();
    if (UPSet.HasRows == false) { Response.Redirect("eddev.aspx?error=errt&url=" + URL); }
    else { Response.Redirect("eddev.aspx?error=ok&url=" + New_URL); }
    UPSet.Close();
    UPLook.Dispose();  
    }
    else if (DelResp != "OK"){
        Response.Redirect("eddev.aspx?error=errt&url=" + URL); 
        CreResult = sd.DeleteARecord(Host, Dom);
    }
    Conn.Close();
    Dispose();
%>
<script runat="server">
    //Validate input + cross site scriptng block.
   bool IsOKinput(string input){

   if ((input.Substring(0,1) == "-") || (input.Substring(input.Length - 1) == "-")){ return false;}
          
          if ((input == null) || (input == "")) { return false; }
          if (input.Length >= 64) { return false; }
            int nChar;
            input = input.ToLower();
            foreach (char i in input)
               {
                nChar = Convert.ToInt32(i);
                   if (nChar != 45) {
              if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }   
              else { return false; }
                   }   
                }
                return true;   
            }
        //Validate input + cross site scriptng block.
    bool IsOKurl(string input)
    {

        if ((input.Substring(0, 1) == "-") || (input.Substring(input.Length - 1) == "-")) { return false; }

        if ((input == null) || (input == "")) { return false; }
        int nChar;
        input = input.ToLower();
        foreach (char i in input)
        {
            nChar = Convert.ToInt32(i);
            if ((nChar != 45) && (nChar != 46))
            {
                if ((nChar > 47 && nChar < 58) || (nChar > 96 && nChar < 123)) { }
                else { return false; }
            }
        }
        return true;
    }
    
    
</script>